﻿using System;
using System.Collections.Generic;
using System.Text;

namespace PerfectCS_2012
{
    class Program_MusicPlayer
    {
        public Program_MusicPlayer(MusicAlbum musicAlbum)
        {
            m_musicAlbum = musicAlbum;

            // ----
            m_musicPlayers = new MusicPlayer[]
            {
                new RecordPlayer(musicAlbum),
                new CassettePlayer(musicAlbum),
                new CDPlayer(musicAlbum),
                new MP3Player(musicAlbum),
            };
            foreach (MusicPlayer musicPlayer in m_musicPlayers)
            {
                DigitalPlayer digitalPlayer = musicPlayer as DigitalPlayer;
                if (digitalPlayer != null)
                {
                    digitalPlayer.MusicStartedEvent += new MusicStartedDelegate(this.MusicStarted);
                }
            }
         }
        // --------
        private MusicAlbum m_musicAlbum;
        private MusicPlayer[] m_musicPlayers;

        // --------
        public void ReportPlayerTypes()
        {
            foreach(MusicPlayer musicPlayer in m_musicPlayers)
            {
                string playerType = musicPlayer.GetPlayerType();
                ConsoleTrace.WriteValue("MusicPlayer.PlayerType", playerType);
            }
        }

        // --------
        public void Play()
        {
            foreach (MusicPlayer musicPlayer in m_musicPlayers)
            {
                musicPlayer.Play();
            }
        }
        // --------
        private void MusicStarted(int musicIndex, Music music)
        {
            ConsoleTrace.WriteValueList("MusicPlayer.MusicStarted", musicIndex, music.Title, music.Artist);
        }

    }
}
