﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PerfectCS_2012
{
    public static class Example_ExtensionMethod
    {
        public static string JapaneseNumber(this string text)
        {
            string japaneseNumber = string.Empty;
            foreach (char _char in text)
            {
                char japaneseChar = _char;
                // ----
                int nChar = (int)_char;
                if(nChar >= '0' && nChar <= '9')
                {
                    japaneseChar = (char)(nChar - '0' + '０');
                }
                japaneseNumber += japaneseChar;
            }
            return japaneseNumber;
        }
        // --------
        public static string AsciiNumber(this string text, int x)
        {
            string asciiNumber = string.Empty;
            foreach(char _char in text)
            {
                char asciiChar = _char;
                switch (_char)
                {
                    case '０': asciiChar = '0'; break;
                    case '１': asciiChar = '1'; break;
                    case '２': asciiChar = '2'; break;
                    case '３': asciiChar = '3'; break;
                    case '４': asciiChar = '4'; break;
                    case '５': asciiChar = '5'; break;
                    case '６': asciiChar = '6'; break;
                    case '７': asciiChar = '7'; break;
                    case '８': asciiChar = '8'; break;
                    case '９': asciiChar = '9'; break;
                    default: break;
                }
                asciiNumber += asciiChar;
            }
            return asciiNumber;
        }

    }
}

namespace ExtensionMethods
{
    public static class MyExtensions
    {
        public static int WordCount(this String str)
        {
            return str.Split(new char[] { ' ', '.', '?' }, StringSplitOptions.RemoveEmptyEntries).Length;
        }
    }
}


