﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PerfectCS_2012
{
    class Example_LambdaExpression
    {
		// --------
        public Example_LambdaExpression(Node[] nodes)
		{
			m_nodes = new Nodes(nodes);
#if false
			m_matchNodeHandler = IsMatchNode;
#endif
		}

		// --------
		private Nodes m_nodes;
#if false
		private Nodes.MatchNodeHandler m_matchNodeHandler;
		// --------
		private bool IsMatchNode(Node node, string key)
		{
			return (node != null && node.Name == key);
		}
#else
#if false
        // ---- 匿名メソッド
		private Nodes.MatchNodeHandler m_matchNodeHandler =
        delegate(Node node, string key)
		{
			return (node != null && node.Name == key);
		};
#else
        // ---- ラムダ式
        private Nodes.MatchNodeHandler m_matchNodeHandler =
        (Node node, string key) => (node != null && node.Name == key);
#endif
#endif
		// --------
		public Node Find(string name)
		{
			return m_nodes.Find(m_matchNodeHandler, name);
		}
    }
}
