﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;

//using System.Data.Linq;

// --------
using System.Data;
using System.Data.SqlClient;

// --------
namespace PerfectCS_2012
{
    public class Exapmle_LINQtoDataSet
    {
        public Exapmle_LINQtoDataSet()
        {
            // ---- データソース
            string connectionString = "Server=localhost;" + "User ID=sa;" + "Password=knowlbo;" + "Database=PerfectCS_2012;";
            m_sqlConnection = new SqlConnection(connectionString);
            m_sqlConnection.Open();

            // ----
            m_dataSet = new DataSet();
            // ----
            string commandText = ("select " + c_tableName + ".*");
            commandText += (" from " + c_tableName);
            // ---- 
            SqlCommand sqlCommand = new SqlCommand();
            sqlCommand.Connection = m_sqlConnection;
            sqlCommand.CommandType = CommandType.Text;
            sqlCommand.CommandText = commandText;
            // ----
            SqlDataAdapter sqlDataAdapter = new SqlDataAdapter();
            sqlDataAdapter.SelectCommand = sqlCommand;
            sqlDataAdapter.Fill(m_dataSet, c_tableName);
            // ----
        }
        private SqlConnection m_sqlConnection;
        private DataSet m_dataSet;
        private const string c_tableName = "Table_CityMonthlyTemperatures";

        // --------
        public void Select(string cityName, double borderTemp)
        {
            DataTable dataTable = m_dataSet.Tables[c_tableName];

            // ---- ①クエリの作成
            var query =
                from cityMonthlyTemperature in dataTable.AsEnumerable()
                where (cityMonthlyTemperature.Field<string>("CityName")).Trim() == cityName &&
                        cityMonthlyTemperature.Field<double>("MaxTemp") >= borderTemp
                orderby cityMonthlyTemperature.Field<double>("MaxTemp") descending
                select new
                {
                    CityName = (cityMonthlyTemperature.Field<string>("CityName")).Trim(),
                    Month = cityMonthlyTemperature.Field<int>("Month"),
                    MaxTemp = cityMonthlyTemperature.Field<double>("MaxTemp"),
                    MinTemp = cityMonthlyTemperature.Field<double>("MinTemp"),
                    Mark = cityMonthlyTemperature.Field<string>("Mark")
                };


            // ---- ②クエリの実行
            Console.WriteLine("-------- Exapmle_LINQtoDataSet");
            foreach (var cityMonthlyTemperature in query)
            {
                Console.WriteLine("{0}[{1:d2}] {2:n1} - {3:n1} {4}",
                    cityMonthlyTemperature.CityName.Trim(),
                    cityMonthlyTemperature.Month,
                    cityMonthlyTemperature.MaxTemp,
                    cityMonthlyTemperature.MinTemp,
                    cityMonthlyTemperature.Mark);
            }
        }

    }
}
