﻿#define ANONYMITY

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PerfectCS_2012
{
    public class Exapmle_LINQtoObjects
    {
        public Exapmle_LINQtoObjects()
        {
            // -------- データソース
            MonthlyTemperature[] monthlyTemperatures_Tokyo = new MonthlyTemperature[]
            {
                new MonthlyTemperature( 1,     9.8,    2.1),
                new MonthlyTemperature( 2,    10.0,    2.4),
                new MonthlyTemperature( 3,    12.9,    5.1),
                new MonthlyTemperature( 4,    18.4,   10.5),
                new MonthlyTemperature( 5,    22.7,   15.1),
                new MonthlyTemperature( 6,    25.2,   18.9),
                new MonthlyTemperature( 7,    29.0,   22.5),
                new MonthlyTemperature( 8,    30.8,   24.2),
                new MonthlyTemperature( 9,    26.8,   20.7),
                new MonthlyTemperature(10,    21.6,   15.0),
                new MonthlyTemperature(11,    16.7,    9.5),
                new MonthlyTemperature(12,    12.3,    4.6),
            };
           
            // --------
            m_cities = new City[]
            {
                new City(){Name = "Tokyo",      JapaneseName = "東京",      Latitude=35.41, Longitude=139.45, MonthlyTemperatures=monthlyTemperatures_Tokyo},
                new City(){Name = "London",     JapaneseName = "ロンドン",  Latitude=51.30, Longitude=-0.10},
                new City(){Name = "Paris",      JapaneseName = "パリ",      Latitude=48.52, Longitude=2.22},
                new City(){Name = "Berlin",     JapaneseName = "ベルリン",  Latitude=52.30, Longitude=13.22},
                new City(){Name = "Rome",       JapaneseName = "ローマ",    Latitude=41.53, Longitude=12.30},
                new City(){Name = "Honolulu",   JapaneseName = "ホノルル",  Latitude=21.19, Longitude=-157.51},
            };
#if false
            // --------
            m_cityMonthlyTemperatures = new CityMonthlyTemperature[]
            {
                new CityMonthlyTemperature(c_cityName_Tokyo,     1,     9.8,    2.1),
                new CityMonthlyTemperature(c_cityName_Tokyo,     2,    10.0,    2.4),
                new CityMonthlyTemperature(c_cityName_Tokyo,     3,    12.9,    5.1),
                new CityMonthlyTemperature(c_cityName_Tokyo,     4,    18.4,   10.5),
                new CityMonthlyTemperature(c_cityName_Tokyo,     5,    22.7,   15.1),
                new CityMonthlyTemperature(c_cityName_Tokyo,     6,    25.2,   18.9),
                new CityMonthlyTemperature(c_cityName_Tokyo,     7,    29.0,   22.5),
                new CityMonthlyTemperature(c_cityName_Tokyo,     8,    30.8,   24.2),
                new CityMonthlyTemperature(c_cityName_Tokyo,     9,    26.8,   20.7),
                new CityMonthlyTemperature(c_cityName_Tokyo,    10,    21.6,   15.0),
                new CityMonthlyTemperature(c_cityName_Tokyo,    11,    16.7,    9.5),
                new CityMonthlyTemperature(c_cityName_Tokyo,    12,    12.3,    4.6),
                // --------
                new CityMonthlyTemperature(c_cityName_Rome,      1,    12,    3),
                new CityMonthlyTemperature(c_cityName_Rome,      2,    13,    4),
                new CityMonthlyTemperature(c_cityName_Rome,      3,    15,    5),
                new CityMonthlyTemperature(c_cityName_Rome,      4,    19,    7),
                new CityMonthlyTemperature(c_cityName_Rome,      5,    23,   12),
                new CityMonthlyTemperature(c_cityName_Rome,      6,    28,   15),
                new CityMonthlyTemperature(c_cityName_Rome,      7,    31,   18),
                new CityMonthlyTemperature(c_cityName_Rome,      8,    31,   18),
                new CityMonthlyTemperature(c_cityName_Rome,      9,    28,   15),
                new CityMonthlyTemperature(c_cityName_Rome,     10,    22,   11),
                new CityMonthlyTemperature(c_cityName_Rome,     11,    17,    7),
                new CityMonthlyTemperature(c_cityName_Rome,     12,    13,    4),
            };
#else
            // -------- コレクション初期化子
            m_cityMonthlyTemperatures = new List<CityMonthlyTemperature>
            {
                new CityMonthlyTemperature(c_cityName_Tokyo,     1,     9.8,    2.1),
                new CityMonthlyTemperature(c_cityName_Tokyo,     2,    10.0,    2.4),
                new CityMonthlyTemperature(c_cityName_Tokyo,     3,    12.9,    5.1),
                new CityMonthlyTemperature(c_cityName_Tokyo,     4,    18.4,   10.5),
                new CityMonthlyTemperature(c_cityName_Tokyo,     5,    22.7,   15.1),
                new CityMonthlyTemperature(c_cityName_Tokyo,     6,    25.2,   18.9),
                new CityMonthlyTemperature(c_cityName_Tokyo,     7,    29.0,   22.5),
                new CityMonthlyTemperature(c_cityName_Tokyo,     8,    30.8,   24.2),
                new CityMonthlyTemperature(c_cityName_Tokyo,     9,    26.8,   20.7),
                new CityMonthlyTemperature(c_cityName_Tokyo,    10,    21.6,   15.0),
                new CityMonthlyTemperature(c_cityName_Tokyo,    11,    16.7,    9.5),
                new CityMonthlyTemperature(c_cityName_Tokyo,    12,    12.3,    4.6),
                // --------
                new CityMonthlyTemperature(c_cityName_Rome,      1,    12,    3),
                new CityMonthlyTemperature(c_cityName_Rome,      2,    13,    4),
                new CityMonthlyTemperature(c_cityName_Rome,      3,    15,    5),
                new CityMonthlyTemperature(c_cityName_Rome,      4,    19,    7),
                new CityMonthlyTemperature(c_cityName_Rome,      5,    23,   12),
                new CityMonthlyTemperature(c_cityName_Rome,      6,    28,   15),
                new CityMonthlyTemperature(c_cityName_Rome,      7,    31,   18),
                new CityMonthlyTemperature(c_cityName_Rome,      8,    31,   18),
                new CityMonthlyTemperature(c_cityName_Rome,      9,    28,   15),
                new CityMonthlyTemperature(c_cityName_Rome,     10,    22,   11),
                new CityMonthlyTemperature(c_cityName_Rome,     11,    17,    7),
                new CityMonthlyTemperature(c_cityName_Rome,     12,    13,    4),
            };
#endif
        }
        //xprivate Country[] m_countries;
        private City[] m_cities;
#if false
        private CityMonthlyTemperature[] m_cityMonthlyTemperatures;
#else
        private List<CityMonthlyTemperature> m_cityMonthlyTemperatures;
#endif
        private const string c_cityName_Tokyo = "Tokyo";
        private const string c_cityName_Rome = "Rome";

        // --------
        public void Select(string cityName, double borderTemp)
        {
#if ANONYMITY
            // ---- ①クエリの作成
            var query =
                from CityMonthlyTemperature cityMonthlyTemperature in m_cityMonthlyTemperatures//-.AsParallel()
                where cityMonthlyTemperature.CityName == cityName &&
                        cityMonthlyTemperature.MaxTemp >= borderTemp
                orderby cityMonthlyTemperature.MaxTemp descending
                //-select cityMonthlyTemperature;
                select new
                {
                    CityName = cityMonthlyTemperature.CityName,
                    Month = cityMonthlyTemperature.Month,
                    MaxTemp = cityMonthlyTemperature.MaxTemp,
                    MinTemp = cityMonthlyTemperature.MinTemp,
                };

            // ---- ②クエリの実行
            Console.WriteLine("-------- Exapmle_LINQtoObjects");
            foreach (var cityMonthlyTemperature in query)
            {
                Console.WriteLine("{0}[{1:d2}] {2:n1} - {3:n1}",
                    cityMonthlyTemperature.CityName.Trim(),
                    cityMonthlyTemperature.Month,
                    cityMonthlyTemperature.MaxTemp,
                    cityMonthlyTemperature.MinTemp);
            }
#else
            // ---- ①クエリの作成
            //var query =
            IEnumerable<CityMonthlyTemperature> query =
                from CityMonthlyTemperature cityMonthlyTemperature in m_cityMonthlyTemperatures
                where cityMonthlyTemperature.CityName == cityName &&
                        cityMonthlyTemperature.MaxTemp >= borderTemp
                orderby cityMonthlyTemperature.MaxTemp descending
                select cityMonthlyTemperature;


            // ---- ②クエリの実行
            Console.WriteLine("-------- Exapmle_LINQtoObjects");
            foreach (CityMonthlyTemperature cityMonthlyTemperature in query)
            {
                Console.WriteLine("{0}[{1:d2}] {2:n1} - {3:n1}",
                    cityMonthlyTemperature.CityName.Trim(),
                    cityMonthlyTemperature.Month,
                    cityMonthlyTemperature.MaxTemp,
                    cityMonthlyTemperature.MinTemp);
            }
#endif
        }
        // --------
        public void Select_from(string cityName, double borderTemp)
        {
            // ---- ①クエリの作成
            var query =
                from City city in m_cities
                where city.Name == cityName
                from MonthlyTemperature monthlyTemperature in city.MonthlyTemperatures
                where monthlyTemperature.MaxTemp >= borderTemp
                orderby monthlyTemperature.MaxTemp descending
                select new
                {
                    CityName = city.Name,
                    Month = monthlyTemperature.Month,
                    MaxTemp = monthlyTemperature.MaxTemp,
                    MinTemp = monthlyTemperature.MinTemp,
               };

            // ---- ②クエリの実行
            Console.WriteLine("-------- Exapmle_LINQtoObjects:from");
            foreach (var cityMonthlyTemperature in query)
            {
                Console.WriteLine("{0}[{1:d2}] {2:n1} - {3:n1}",
                    cityMonthlyTemperature.CityName.Trim(),
                    cityMonthlyTemperature.Month,
                    cityMonthlyTemperature.MaxTemp,
                    cityMonthlyTemperature.MinTemp);
            }
        }
        // --------
        public void Select_select(string cityName, double borderTemp)
        {
            // ---- ①クエリの作成
            var query =
                from CityMonthlyTemperature cityMonthlyTemperature in m_cityMonthlyTemperatures
                where cityMonthlyTemperature.CityName == cityName &&
                        cityMonthlyTemperature.MaxTemp >= borderTemp
                orderby cityMonthlyTemperature.MaxTemp descending
                //-select cityMonthlyTemperature;
                select new CityMonthlyTemperature()
                {
                    CityName = cityMonthlyTemperature.CityName,
                    Month = cityMonthlyTemperature.Month,
                    MaxTemp = cityMonthlyTemperature.MaxTemp,
                    MinTemp = cityMonthlyTemperature.MinTemp,
                };
#if false
                select new
                {
                    CityName = cityMonthlyTemperature.CityName,
                    Month = cityMonthlyTemperature.Month,
                    MaxTemp = cityMonthlyTemperature.MaxTemp,
                    MinTemp = cityMonthlyTemperature.MinTemp,
                };
#endif
#if false
                select new
                {
                    cityMonthlyTemperature.CityName,
                    cityMonthlyTemperature.Month,
                    cityMonthlyTemperature.MaxTemp,
                    cityMonthlyTemperature.MinTemp,
                };
#endif

            // ---- ②クエリの実行
            Console.WriteLine("-------- Exapmle_LINQtoObjects:select");
            foreach (var cityMonthlyTemperature in query)
            {
                Console.WriteLine("{0}[{1:d2}] {2:n1} - {3:n1}",
                    cityMonthlyTemperature.CityName.Trim(),
                    cityMonthlyTemperature.Month,
                    cityMonthlyTemperature.MaxTemp,
                    cityMonthlyTemperature.MinTemp);
            }
        }
        // --------
        public void Select_group(double borderTemp)
        {
            // ---- ①クエリの作成
            var query =
                from CityMonthlyTemperature cityMonthlyTemperature in m_cityMonthlyTemperatures
                where cityMonthlyTemperature.MaxTemp >= borderTemp
                orderby cityMonthlyTemperature.MaxTemp descending
                group cityMonthlyTemperature by cityMonthlyTemperature.CityName;

            // ---- ②クエリの実行
            Console.WriteLine("-------- Exapmle_LINQtoObjects:group");
            foreach (IGrouping<string, CityMonthlyTemperature> cityMonthlyTemperatureGroup in query)
            {
                Console.WriteLine("--------");
                foreach (var cityMonthlyTemperature in cityMonthlyTemperatureGroup)
                {
                    Console.WriteLine("{0}[{1:d2}] {2:n1} - {3:n1}",
                        cityMonthlyTemperature.CityName.Trim(),
                        cityMonthlyTemperature.Month,
                        cityMonthlyTemperature.MaxTemp,
                        cityMonthlyTemperature.MinTemp);
                }
            }
        }
        // --------
        public void Select_InnerJoin(string cityName, double borderTemp)
        {
            // ----
#if true                
            var query =
                from CityMonthlyTemperature cityMonthlyTemperature in m_cityMonthlyTemperatures
                where cityMonthlyTemperature.CityName == cityName &&
                    cityMonthlyTemperature.MaxTemp >= borderTemp
                orderby cityMonthlyTemperature.MaxTemp descending
                join City city in m_cities on cityMonthlyTemperature.CityName equals city.Name
                //xjoin City city in m_cities on city.Name equals cityMonthlyTemperature.CityName
                select new
                {
                    CityName = city.JapaneseName,
                    // ----
                    //-CityName = cityMonthlyTemperature.CityName,
                    Month = cityMonthlyTemperature.Month,
                    MaxTemp = cityMonthlyTemperature.MaxTemp,
                    MinTemp = cityMonthlyTemperature.MinTemp
                };
            // ---- クエリの実行
            Console.WriteLine("-------- Exapmle_LINQtoObjects:InnerJoin");
            foreach (var capitalMonthlyTemperature in query)
            {
                Console.WriteLine("{0}[{1:d2}] {2:n1} - {3:n1}",
                    capitalMonthlyTemperature.CityName.Trim(),
                    capitalMonthlyTemperature.Month,
                    capitalMonthlyTemperature.MaxTemp,
                    capitalMonthlyTemperature.MinTemp);
            }
#else
            var query =
                from CityMonthlyTemperature cityMonthlyTemperature in m_cityMonthlyTemperatures
                where cityMonthlyTemperature.MaxTemp >= borderTemp
                orderby cityMonthlyTemperature.MaxTemp descending
                join Country country in m_countries on cityMonthlyTemperature.CityName equals country.CapitalName
                //xjoin Country country in m_countries on country.CapitalName equals cityMonthlyTemperature.CityName
                select new
                {
                    CountryName = country.CountryName,
                    // ----
                    CityName = cityMonthlyTemperature.CityName,
                    Month = cityMonthlyTemperature.Month,
                    MaxTemp = cityMonthlyTemperature.MaxTemp,
                    MinTemp = cityMonthlyTemperature.MinTemp
                };
            // ---- クエリの実行
            Console.WriteLine("-------- Exapmle_LINQtoObjects:InnerJoin");
            foreach (var capitalMonthlyTemperature in query)
            {
                Console.WriteLine("{0}[{1:d2}] {2:n1} - {3:n1} in {4}",
                    capitalMonthlyTemperature.CityName.Trim(),
                    capitalMonthlyTemperature.Month,
                    capitalMonthlyTemperature.MaxTemp,
                    capitalMonthlyTemperature.MinTemp,
                    capitalMonthlyTemperature.CountryName);
            }
#endif
        }
    }
}
