﻿#define OR_DESIGNER
// --------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
// --------
//using System.Data;
//using System.Data.SqlClient;

using System.Data.Linq;

// --------
namespace PerfectCS_2012
{
    public class Exapmle_LINQtoSQL
    {
        public Exapmle_LINQtoSQL()
        {
            // ---- データソース
#if OR_DESIGNER
            m_dataContext = new PerfectCS_2012_DataContext(c_connection);     // -- by O/R Designer
#else
            m_dataContext = new DataContext(c_connection);
            //m_dataContext = new DataContext_PerfectCS_2012(c_connection);    // -- my DataContext
#endif

            //-m_dataContext.Log = Console.Out;
            // ---- Log（TextWriter）としてConsole出力を割り当てる！
        }
        private const string c_connection = "Server=localhost;" + "User ID=sa;" + "Password=knowlbo;" + "Database=PerfectCS_2012;";
#if OR_DESIGNER
        private PerfectCS_2012_DataContext m_dataContext;
#else
        private DataContext m_dataContext;
        //private DataContext_PerfectCS_2012 m_dataContext;
#endif
        // -------- 選択
        public void Select(string cityName, double borderTemp)
        {
#if OR_DESIGNER
            System.Data.Linq.Table<Model_CityMonthlyTemperatures> table_CityMonthlyTemperatures = m_dataContext.Model_CityMonthlyTemperatures;

            // ---- ①クエリの作成
            var query =
                from cityMonthlyTemperature in table_CityMonthlyTemperatures
                where cityMonthlyTemperature.CityName == cityName &&
                        cityMonthlyTemperature.MaxTemp >= borderTemp
                orderby cityMonthlyTemperature.MaxTemp descending
                select cityMonthlyTemperature;
/*
            var query =
              (from cityMonthlyTemperature in table_CityMonthlyTemperatures
                 where cityMonthlyTemperature.CityName == cityName
                 select cityMonthlyTemperature)
                 .Skip(6).Take(3);
*/
#else
            System.Data.Linq.Table<CityMonthlyTemperature> table_CityMonthlyTemperatures = m_dataContext.GetTable<CityMonthlyTemperature>();
            //Table<MonthlyTemperature> table_CityMonthlyTemperatures = m_dataContext.Table_MonthlyTemperatures;
            
            //m_dataContext.ExecuteCommand();
            // ---- ①クエリの作成
            var query =
                m_dataContext.ExecuteQuery<CityMonthlyTemperature>
                ("SELECT * FROM Table_CityMonthlyTemperatures WHERE CityName = {0}",
                cityName);
#endif
            // ---- ②クエリの実行
            Console.WriteLine("-------- Exapmle_LINQtoSQL");
            foreach (var cityMonthlyTemperature in query)
            {
#if true
                Console.WriteLine("{0}[{1:d2}] {2:n1} - {3:n1} {4}",
                    cityMonthlyTemperature.CityName.Trim(),
                    cityMonthlyTemperature.Month,
                    cityMonthlyTemperature.MaxTemp,
                    cityMonthlyTemperature.MinTemp,
                    cityMonthlyTemperature.Mark);
#else
                new CityMonthlyTemperature(
                    cityMonthlyTemperature.CityName,
                    (int)cityMonthlyTemperature.Month,
                    (double)cityMonthlyTemperature.MaxTemp,
                    (double)cityMonthlyTemperature.MinTemp,
                    cityMonthlyTemperature.Mark)
                    .Trace();
#endif
            }
        }

        // -------- 挿入
#if OR_DESIGNER
        public void Insert(Model_CityMonthlyTemperatures[] cityMonthlyTemperatures)
        {
            Table<Model_CityMonthlyTemperatures> table_CityMonthlyTemperatures = m_dataContext.Model_CityMonthlyTemperatures;
            // ----
            foreach (Model_CityMonthlyTemperatures cityMonthlyTemperature in cityMonthlyTemperatures)
            {
                string id = cityMonthlyTemperature.CityName + cityMonthlyTemperature.Month.Value.ToString("d2");
                cityMonthlyTemperature.Id = id;
                table_CityMonthlyTemperatures.InsertOnSubmit(cityMonthlyTemperature);

/*                Model_CityMonthlyTemperatures model_MonthlyTemperatures = new Model_CityMonthlyTemperatures();
                // ----
                model_MonthlyTemperatures.Id = id;
                model_MonthlyTemperatures.CityName = cityMonthlyTemperature.CityName;
                model_MonthlyTemperatures.Month = cityMonthlyTemperature.Month;
                model_MonthlyTemperatures.MaxTemp = cityMonthlyTemperature.MaxTemp;
                model_MonthlyTemperatures.MinTemp = cityMonthlyTemperature.MinTemp; 
                // ----
                table_CityMonthlyTemperatures.InsertOnSubmit(model_MonthlyTemperatures);
*/
            }
            // ----
            m_dataContext.SubmitChanges();
        }
#else
        public void Insert(CityMonthlyTemperature[] cityMonthlyTemperatures)
        {
            Table<CityMonthlyTemperature> table_CityMonthlyTemperatures = m_dataContext.GetTable<CityMonthlyTemperature>();
            // ----
            foreach (CityMonthlyTemperature cityMonthlyTemperature in cityMonthlyTemperatures)
            {
                string id = cityMonthlyTemperature.CityName + cityMonthlyTemperature.Month.ToString("d2");
                cityMonthlyTemperature.Id = id;
                // ----
                table_CityMonthlyTemperatures.InsertOnSubmit(cityMonthlyTemperature);
            }
            // ----
            m_dataContext.SubmitChanges();
        }
#endif


        // -------- 更新
        public void Update(string cityName, double borderTemp, string mark)
        {
#if OR_DESIGNER
            Table<Model_CityMonthlyTemperatures> table_CityMonthlyTemperatures = m_dataContext.Model_CityMonthlyTemperatures;
#else
            Table<CityMonthlyTemperature> table_CityMonthlyTemperatures = m_dataContext.GetTable<CityMonthlyTemperature>();
#endif
            // ---- クエリの作成
            var query =
                from cityMonthlyTemperature in table_CityMonthlyTemperatures
                where cityMonthlyTemperature.CityName == cityName &&
                        cityMonthlyTemperature.MaxTemp >= borderTemp
                select cityMonthlyTemperature;

            // ---- クエリの（遅延）実行
            foreach (var cityMonthlyTemperature in query)
            {
                cityMonthlyTemperature.Mark = mark;
            }
            // ----
            m_dataContext.SubmitChanges();
        }

        // -------- 削除
        public void Delete(string cityName, string mark)
        {
#if OR_DESIGNER
            Table<Model_CityMonthlyTemperatures> table_CityMonthlyTemperatures = m_dataContext.Model_CityMonthlyTemperatures;
#else
            Table<CityMonthlyTemperature> table_CityMonthlyTemperatures = m_dataContext.GetTable<CityMonthlyTemperature>();
#endif
            // ---- クエリの作成
            var query =
                from cityMonthlyTemperature in table_CityMonthlyTemperatures
                where cityMonthlyTemperature.CityName == cityName &&
                        cityMonthlyTemperature.Mark == mark
                select cityMonthlyTemperature;

            // ---- クエリの（遅延）実行
            foreach (var cityMonthlyTemperature in query)
            {
                table_CityMonthlyTemperatures.DeleteOnSubmit(cityMonthlyTemperature);
            }
            // ----
            m_dataContext.SubmitChanges();
        }
        // --------
        public void Delete_NullMark(string cityName)
        {
#if OR_DESIGNER
            Table<Model_CityMonthlyTemperatures> table_CityMonthlyTemperatures = m_dataContext.Model_CityMonthlyTemperatures;
#else
            Table<CityMonthlyTemperature> table_CityMonthlyTemperatures = m_dataContext.GetTable<CityMonthlyTemperature>();
#endif
            // ---- クエリの作成
            var query =
                from cityMonthlyTemperature in table_CityMonthlyTemperatures
                where cityMonthlyTemperature.CityName == cityName &&
                        cityMonthlyTemperature.Mark == null
                select cityMonthlyTemperature;

            // ---- クエリの（遅延）実行
            foreach (var cityMonthlyTemperature in query)
            {
                table_CityMonthlyTemperatures.DeleteOnSubmit(cityMonthlyTemperature);
            }
            // ----
            m_dataContext.SubmitChanges();
        }
    }
}
