﻿using System;
using System.Windows;
using System.Windows.Controls;

// モードレスウィンドウ（TimeSpanWindow）→呼び出し元への通知用デリゲート型
public delegate void TimeSpanChangedEventHandler(object sender, EventArgs e);

namespace WpfApplication
{
    /// <summary>
    /// TimeSpanWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class TimeSpanWindow : Window
    {
        public TimeSpanWindow()
        {
            InitializeComponent();
        }

        // 更新間隔の取得
        public int TimeSpan
        {
            get
            {
                ComboBoxItem item = this.cmbTimeSpan.SelectedItem as ComboBoxItem;
                return int.Parse(item.Content.ToString());
            }
        }

        // モードレスウィンドウ（TimeSpanWindow）→呼び出し元への通知用イベント
        public event TimeSpanChangedEventHandler TimeSpanChanged;

        private void cmbTimeSpan_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // イベントにより通知
            if (null != TimeSpanChanged)
                TimeSpanChanged(this, EventArgs.Empty);
        }

        // 閉じるボタンクリックイベントハンドラ
        private void btnClose_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
    }
}