﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace ControlSample
{
    /// <summary>
    /// MediaElementSample.xaml の相互作用ロジック
    /// </summary>
    public partial class MediaElementSample : Window
    {
        public MediaElementSample()
        {
            InitializeComponent();
        }

        private void btnPause_Click(object sender, RoutedEventArgs e)
        {
            if(mediaElement1.CanPause)
                this.mediaElement1.Pause();
        }

        private void btnStop_Click(object sender, RoutedEventArgs e)
        {
            this.mediaElement1.Stop();
        }

        private void btnPlay_Click(object sender, RoutedEventArgs e)
        {
            this.mediaElement1.Play();
        }

        private void btnOpenFile_Click(object sender, RoutedEventArgs e)
        {
            Microsoft.Win32.OpenFileDialog dlg = new Microsoft.Win32.OpenFileDialog();
            dlg.Filter = "オーディオ/ビデオ ファイル (.wmv)|*.wmv|AVI File(.avi)|*.avi";
            if (dlg.ShowDialog(this).Value)
            {
                this.mediaElement1.Source = new Uri(dlg.FileName);
            }
        }

        private void sldSpeed_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            this.mediaElement1.SpeedRatio = sldSpeed.Value;
        }

        private void sldVolume_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            this.mediaElement1.Volume = sldVolume.Value;
        }



    }
}
