﻿using System;
using System.Windows.Controls;
using System.Collections.Generic;

namespace DataBindSample
{
    public class DateRangeValidater : ValidationRule
    {
        /// <summary>
        /// 検証処理
        /// </summary>
        /// <param name="value"></param>
        /// <param name="cultureInfo"></param>
        /// <returns></returns>
        public override ValidationResult Validate(object value, System.Globalization.CultureInfo cultureInfo)
        {
            DateTime dt;
            
            if (DateTime.TryParse(value.ToString(), out dt))
            {
                if (MinDate > dt || MaxDate < dt)
                {
                    return new ValidationResult(false, "2000/1/1～2100/12/31までの範囲で入力してください");
                }
                else
                {
                    // 妥当な値であった
                    return new ValidationResult(true, null);
                }
            }
            else
            {
                return new ValidationResult(false, "日付の書式が正しくありません");
            }
        }

        /// <summary>
        /// 妥当な日付の最少値
        /// </summary>
        public DateTime MinDate
        {
            get { return this._minDate; }
            set { this._minDate = value; }
        }
        private DateTime _minDate = DateTime.MinValue;

        /// <summary>
        /// 妥当な日付の最大値
        /// </summary>
        public DateTime MaxDate
        {
            get { return this._maxDate; }
            set { this._maxDate = value; }
        }
        private DateTime _maxDate = DateTime.MaxValue;
    }
}
