﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
// --------
using System.Net;
// -------- ▼（for 共有ソース）
using Windows.ApplicationModel.DataTransfer;
// -------- ▼（for MessageDialog、PopupMenu）
using Windows.UI.Popups;
// -------- ▼（for バッジ、ライブタイル、トースト）
using Windows.UI.Notifications;
using Windows.Data.Xml.Dom;
// -------- ▼（for StorageFile、FileOpenPicker）
using Windows.Storage;
using Windows.Storage.Pickers;
// -------- ▼（for ApplicationView）
using Windows.UI.ViewManagement;

// 基本ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234237 を参照してください

namespace PerfectCS_2012
{
    /// <summary>
    /// 多くのアプリケーションに共通の特性を指定する基本ページ。
    /// </summary>
    public sealed partial class BasicPage1 : PerfectCS_2012.Common.LayoutAwarePage
    {
        // ---- ▼
        private const string c_initialUrl = "http://www.knowlbo.co.jp/books/perfect_csharp_2nd/";
        //-private const string c_initialUrl = "http://www.Knowlbo.co.jp";
        //-private const string c_initialUrl = "http://www.gihyo.jp/book/genre?s=0604";

        public BasicPage1()
        {
            this.InitializeComponent();

            // ---- ▼
            if (string.IsNullOrEmpty(BasicPage1.TargetUrl))
            {
                BasicPage1.TargetUrl = c_initialUrl;
            }
            this.controlTargetUrl = c_initialUrl;

            // ---- ▼共有ソースのイベントハンドラの登録（for 共有ソース）。
            this.RegisterForShareSource();

            // ---- ▼ポップアップメニュー
            this.textBlock_SelectedUrl.RightTapped += new RightTappedEventHandler(this.TargetWebPage_RightTapped);
            //-this.webView_TargetWebPage.RightTapped += new RightTappedEventHandler(this.TargetWebPage_RightTapped);

        }

        // -------- ▼ポップアップメニューのイベントハンドラ
        private async void TargetWebPage_RightTapped(object sender, RightTappedRoutedEventArgs e)
        {
            string selectedUrl = this.textBlock_SelectedUrl.Text;
            //-string selectedUrl = this.webView_TargetWebPage.Source.AbsoluteUri;
            // ---- ※表示URLを取得。

            var menu = new PopupMenu();
            menu.Commands.Add(new UICommand("コピー", (command) =>
            {
                var dataPackage = new DataPackage();
                dataPackage.SetText(selectedUrl);
                Clipboard.SetContent(dataPackage);
            }));
            
            // ---- ※セパレーター
            menu.Commands.Add(new UICommandSeparator());

            menu.Commands.Add(new UICommand("対象URLとして設定", (command) =>
            {
                // ---- 対象URLの変更。
                if (!(string.IsNullOrEmpty(selectedUrl)))
                {
                    this.ChangeTargetUrl(selectedUrl);
                }
            }));

            FrameworkElement element = (FrameworkElement)sender;
            Point point = e.GetPosition(null);
            Rect selection = new Rect(point, new Size(element.ActualWidth, element.ActualHeight));
            var selectionCommand = await menu.ShowForSelectionAsync(selection);
            if (selectionCommand == null)
            {
                // ---- ※未選択。
            }
        }
        // -------- ▼共有ソースのイベントハンドラの登録（for 共有ソース）。
        private void RegisterForShareSource()
        {
            DataTransferManager dataTransferManager = DataTransferManager.GetForCurrentView();
            // ---- ※現在のウィンドウに割り当てられているDataTransferManagerクラスのインスタンスを取得。

            // ---- ※共有チャーム（接続チャーム）に対応するDataRequestedイベントハンドラを登録。
            try
            {
                //-dataTransferManager.DataRequested += new TypedEventHandler<DataTransferManager, DataRequestedEventArgs>(this.ShareTextHandler);
                dataTransferManager.DataRequested += new TypedEventHandler<DataTransferManager, DataRequestedEventArgs>(this.ShareSourceHandler);
            }
            catch (InvalidOperationException invalidOperationException)
            {
                string message = invalidOperationException.Message;
                // ----
            }
        }
#if false
        // -------- ▼共有テキストハンドラ（for 共有ソース）。
        private void ShareTextHandler(DataTransferManager sender, DataRequestedEventArgs e)
        {
            DataRequest request = e.Request;
            request.Data.Properties.Title = "Text : " + BasicPage1.GetHttpTerm(BasicPage1.TargetUrl);
            request.Data.Properties.Description = BasicPage1.TargetUrl;
            request.Data.SetText(BasicPage1.TargetUrl);
        }
#endif
        // -------- ▼共有ソースのイベントハンドラ（for 共有ソース）。
        private void ShareSourceHandler(DataTransferManager sender, DataRequestedEventArgs e)
        {
            DataRequest request = e.Request;
            DataPackage dataPackage = request.Data;
            dataPackage.Properties.Title = BasicPage1.GetHttpTerm(BasicPage1.TargetUrl);
            dataPackage.Properties.Description = BasicPage1.TargetUrl;
            // ----
            dataPackage.SetText(BasicPage1.TargetUrl);             // -- テキストデータ形式の設定
            dataPackage.SetUri(new Uri(BasicPage1.TargetUrl));     // -- URIデータ形式の設定
        }
        // --------

        /// <summary>
        /// このページには、移動中に渡されるコンテンツを設定します。前のセッションからページを
        /// 再作成する場合は、保存状態も指定されます。
        /// </summary>
        /// <param name="navigationParameter">このページが最初に要求されたときに
        /// <see cref="Frame.Navigate(Type, Object)"/> に渡されたパラメーター値。
        /// </param>
        /// <param name="pageState">前のセッションでこのページによって保存された状態の
        /// ディクショナリ。ページに初めてアクセスするとき、状態は null になります。</param>
        protected override void LoadState(Object navigationParameter, Dictionary<String, Object> pageState)
        {
            // ---- ▼セッションデータの復元。
            if (pageState != null)
            {
                if (pageState.ContainsKey(c_key_SelectedDataItem))
                {
                    this.controlSelectedDataItem = pageState[c_key_SelectedDataItem] as DataItem;
                } 
                if (pageState.ContainsKey(c_key_SelectionKey))
                {
                    //-xxx = pageState[c_key_SelectionKey].ToString();
                }
            }
            // ---- ▼アプリデータを復元。
            this.controlTargetUrl = BasicPage1.TargetUrl;

            // ---- ▼リフレッシュ。
            this.Refresh(this.controlTargetUrl, null);
        }

        /// <summary>
        /// アプリケーションが中断される場合、またはページがナビゲーション キャッシュから破棄される場合、
        /// このページに関連付けられた状態を保存します。値は、
        /// <see cref="SuspensionManager.SessionState"/> のシリアル化の要件に準拠する必要があります。
        /// </summary>
        /// <param name="pageState">シリアル化可能な状態で作成される空のディクショナリ。</param>
        protected override void SaveState(Dictionary<String, Object> pageState)
        {
            // ---- ▼セッションデータの保存。
            pageState[c_key_SelectedDataItem] = this.controlSelectedDataItem;
            //-pageState[c_key_SelectionKey] = xxx;
            // ----
        }

        // -------- ▼URLスタック
        private const string c_key_UrlsText = "UrlsText";
        public static List<string> UrlStack
        {
            get
            {
                Windows.Storage.ApplicationDataContainer localSettings = Windows.Storage.ApplicationData.Current.LocalSettings;
                if (localSettings.Values.ContainsKey(c_key_UrlsText))
                {
                    List<string> urlStack = new List<string>();
                    // ----
                    string urlsText = localSettings.Values[c_key_UrlsText] as string;
                    if (!(string.IsNullOrEmpty(urlsText)))
                    {
                        int startIndex = 0;
                        int index;
                        while ((index = urlsText.IndexOf(Environment.NewLine, startIndex)) >= 0)
                        {
                            string url = urlsText.Substring(startIndex, (index - startIndex));
                            urlStack.Add(url);
                            // ----
                            startIndex = index + Environment.NewLine.Length;
                        }
                    }
                    return urlStack;
                }
                return null;
            }
            set
            {
                Windows.Storage.ApplicationDataContainer localSettings = Windows.Storage.ApplicationData.Current.LocalSettings;
                // ----
                string urlsText = null;
                if (value != null)
                {
                    foreach (string url in value)
                    {
                        urlsText += (url + Environment.NewLine);
                    }
                }
                // ----
                localSettings.Values[c_key_UrlsText] = urlsText;
            }
        }
        // -------- ＃プッシュ
        public static void PushUrl(string url)
        {
            List<string> urlStack = BasicPage1.UrlStack;
            if (urlStack == null)
            {
                urlStack = new List<string>();
            }
            // ----
            urlStack.Add(url);
            BasicPage1.UrlStack = urlStack;
        }
        // -------- ＃ポップ
        public static string PopUrl()
        {
            string url = null;
            // ----
            List<string> urlStack = BasicPage1.UrlStack;
            if (urlStack != null &&
                urlStack.Count > 0)
            {
                int index = urlStack.Count - 1;
                url = urlStack[index];
                // ----
                urlStack.RemoveAt(index);
                BasicPage1.UrlStack = urlStack;
            }
            return url;
        }
        // -------- ホーム
        public static string HomeUrl()
        {
            string url = null;
            // ----
            List<string> urlStack = BasicPage1.UrlStack;
            if (urlStack != null &&
                urlStack.Count > 0)
            {
                int index = 0;
                url = urlStack[index];
                // ----
                BasicPage1.UrlStack = null;
            }
            return url;
        }
        // -------- ▼対象URL
        private const string c_key_TargetUrl = "TargetUrl";
        public static string TargetUrl
        {
            get
            {
                Windows.Storage.ApplicationDataContainer localSettings = Windows.Storage.ApplicationData.Current.LocalSettings;
                if (localSettings.Values.ContainsKey(c_key_TargetUrl))
                {
                    string targetUrl = localSettings.Values[c_key_TargetUrl].ToString();
                    if (string.IsNullOrEmpty(targetUrl))
                    {
                        targetUrl = c_initialUrl;
                    }
                    return targetUrl;
                }
                return null;
            }
            set
            {
                if (!(string.IsNullOrEmpty(value)))
                {
                    Windows.Storage.ApplicationDataContainer localSettings = Windows.Storage.ApplicationData.Current.LocalSettings;
                    localSettings.Values[c_key_TargetUrl] = value;
                }
            }
        }
        // -------- ▼対象URL（コントロール）
        private string controlTargetUrl
        {
            get
            {
                return this.textBox_TargetUrl.Text;
            }
            set
            {
                if (value == null)
                {
                    value = string.Empty;
                }
                this.textBox_TargetUrl.Text = value;
            }
        }

        // -------- ▼選択データ項目
        private const string c_key_SelectedDataItem = "SelectedDataItem";
        // -------- ▼選択データ項目（コントロール）
        private DataItem controlSelectedDataItem
        {
            get { return this.listView_PickupUrls.SelectedItem as DataItem; }
            set { this.listView_PickupUrls.SelectedItem = value; }
        }
         
        // -------- ▼選択キー
        private const string c_key_SelectionKey = "SelectionKey";

        // -------- ＃URLの表示
        public void NavigateWebView(string url)
        {
            // ---- 検索対象URLの表示。
            if (!(string.IsNullOrEmpty(url)))
            {
                try
                {
                    this.textBlock_SelectedUrl.Text = url;
#if true
                    this.webView_TargetWebPage.Navigate(new Uri(url));
#else
                    this.ShowBrowser(url);
#endif
                }
                catch (Exception exception)
                {
                    string message = exception.Message;
                }
            }
        }
#if true
        // -------- ＃数値バッジの送信
        public void SendNumBadge(int numValue)
        {
            XmlDocument badgeXml = BadgeUpdateManager.GetTemplateContent(BadgeTemplateType.BadgeNumber);
            // ---- ※数値バッジ用のテンプレートを取得。

            XmlElement badgeElement = (XmlElement)badgeXml.SelectSingleNode("/badge");
            badgeElement.SetAttribute("value", numValue.ToString());
            // ----
            BadgeNotification badgeNotification = new BadgeNotification(badgeXml);
            BadgeUpdateManager.CreateBadgeUpdaterForApplication().Update(badgeNotification);
        }
        // -------- ＃グリフバッジの送信
        public void SendGlyphBadge(string glyphValue)
        {
            XmlDocument badgeXml = BadgeUpdateManager.GetTemplateContent(BadgeTemplateType.BadgeGlyph);
            // ---- ※グリフバッジ用のテンプレートを取得。

            XmlElement badgeElement = (XmlElement)badgeXml.SelectSingleNode("/badge");
            badgeElement.SetAttribute("value", glyphValue);
            // ----
            BadgeNotification badgeNotification = new BadgeNotification(badgeXml);
            BadgeUpdateManager.CreateBadgeUpdaterForApplication().Update(badgeNotification);
        }
        // -------- ＃ライブタイルの送信
        public void SendLiveTile(string text, string imageUrl)
        {
            XmlDocument tileXml = TileUpdateManager.GetTemplateContent(TileTemplateType.TileWideImageAndText01);
            // ---- ※ライブタイル用のテンプレートを取得。

            XmlNodeList tileTextElements = tileXml.GetElementsByTagName("text");
            tileTextElements[0].InnerText = text;
            // ----
            XmlNodeList tileImageElements = tileXml.GetElementsByTagName("image");
            ((XmlElement)tileImageElements[0]).SetAttribute("src", imageUrl);
            ((XmlElement)tileImageElements[0]).SetAttribute("alt", imageUrl);
            // ---- ※alt：代替テキスト。
#if false
            // ---- ※正方形タイル対応。
            XmlDocument squareTileXml = TileUpdateManager.GetTemplateContent(TileTemplateType.TileSquareText04);
            XmlNodeList squareTileTextElements = squareTileXml.GetElementsByTagName("text");
            squareTileTextElements[0].AppendChild(squareTileXml.CreateTextNode(text));
            IXmlNode node = tileXml.ImportNode(squareTileXml.GetElementsByTagName("binding").Item(0), true);
            // ----
            tileXml.GetElementsByTagName("visual").Item(0).AppendChild(node);
#endif
            // ----
            TileNotification tileNotification = new TileNotification(tileXml);
            //-tileNotification.ExpirationTime = DateTimeOffset.UtcNow.AddSeconds(10); // -- 10分
            TileUpdateManager.CreateTileUpdaterForApplication().Update(tileNotification);
        }
#endif
#if true
        // -------- ＃トーストの送信
        public void SendToast(string text, string imageUrl)
        {
            ToastTemplateType toastTemplateType = ToastTemplateType.ToastImageAndText01;
            XmlDocument toastXml = ToastNotificationManager.GetTemplateContent(toastTemplateType);
            // ---- ※トーストのテンプレートを取得。

            XmlNodeList toastTextElements = toastXml.GetElementsByTagName("text");
            toastTextElements[0].AppendChild(toastXml.CreateTextNode(text));
            // ----
            XmlNodeList toastImageElements = toastXml.GetElementsByTagName("image");
            ((XmlElement)toastImageElements[0]).SetAttribute("src", imageUrl);
            ((XmlElement)toastImageElements[0]).SetAttribute("alt", imageUrl);
            // ---- ※alt：代替テキスト。
            IXmlNode toastNode = toastXml.SelectSingleNode("/toast");
            ((XmlElement)toastNode).SetAttribute("duration", "long");
            // ----
            //-XmlElement audio = toastXml.CreateElement("audio");
            //-audio.SetAttribute("silent", "true");
            //-toastNode.AppendChild(audio);
            // ----
            ToastNotification toastNotification = new ToastNotification(toastXml);
            ToastNotificationManager.CreateToastNotifier().Show(toastNotification);
        }
#endif
        // -------- ＃リフレッシュ
        public void Refresh(string targetUrl, string selectionKey)
        {
#if true
            // ---- 検索対象URLの表示。
            this.NavigateWebView(targetUrl);
#endif
            // ---- 検索結果リストの表示。
            string resultText;
            List<DataItem> pickupDataItems = BasicPage1.Find(targetUrl, selectionKey, out resultText);
            this.pageTitle.Text = targetUrl + " [ " + resultText + " ]";
            // ----
#if true
            if (pickupDataItems != null)
            {
                if (pickupDataItems.Count < 100)
                {
                    this.SendNumBadge(pickupDataItems.Count);
                    // ---- ※数値バッジの送信。
                }
                else
                {
                    this.SendGlyphBadge("attention");
                    // ---- ※グリフバッジの送信。
                }

            }
            else
            {
                this.SendGlyphBadge("error");
                // ---- ※グリフバッジの送信。
            }
#endif
            List<DataItem> imegaDataItems = DataItem.SelectImegeDataItems(pickupDataItems);
            // ----
            this.listView_PickupUrls.ItemsSource = pickupDataItems;
            this.listView_ImegeUrls.ItemsSource = imegaDataItems;
            // ----
            this.flipView_ImegeUrls.ItemsSource = imegaDataItems;
#if true
            if (imegaDataItems.Count > 0)
            {
                // ---- ライブタイルの送信
                string pickupUrl = imegaDataItems[0].Description;
                this.SendLiveTile(pickupUrl, pickupUrl);

               // ---- トーストの送信
                this.SendToast(pickupUrl, pickupUrl);
            }
#endif
        }
        // -------- ＃検索
        public static List<DataItem> Find(string targetUrl, string selectionKey, out string resultText)
        {
            System.IO.Stream pageStream = null;
            try
            {
                System.Net.Http.HttpClient httpClient = new System.Net.Http.HttpClient();
                // ---- 指定したURLからデータを取得する。
                System.Threading.Tasks.Task<Stream> task = httpClient.GetStreamAsync(targetUrl);
                task.Wait();
                pageStream = task.Result;
            }
            catch (Exception exception)
            {
                resultText = exception.Message;
                return null;
            }
            // ---- エンコード指定で文字列を取得する。
            // ---- サイトによってエンコードは異なる。
            //-System.Text.Encoding encoding = System.Text.Encoding.GetEncoding("shift-jis");
            System.Text.Encoding encoding = System.Text.Encoding.UTF8;
            StreamReader pageStreamReader = new StreamReader(pageStream, encoding);
            // ----
            string pageText = pageStreamReader.ReadToEnd();
            // ---- dataItemsにhttpテキストを追加。
            List<DataItem> dataItems = new List<DataItem>();
            if (!(string.IsNullOrEmpty(pageText)))
            {
                int startIndex = 0;
                while (startIndex >= 0)
                {
                    string httpText = null;
                    int httpIndex = pageText.IndexOf("http", startIndex);
                    if (httpIndex > 0)
                    {
                        // ---- ひとつ前の文字を区切り文字とする。
                        string delimiter = pageText.Substring((httpIndex - 1), 1);
                        int delimiterIndex = pageText.IndexOf(delimiter, httpIndex);
                        if (delimiterIndex > 0)
                        {
                            httpText = pageText.Substring(httpIndex, (delimiterIndex - httpIndex));
                            startIndex = delimiterIndex + 1;
                        }
                    }
                    // ---- selectionKeyと照合。
                    if (!(string.IsNullOrEmpty(httpText)))
                    {
                        int keyIndex = 0;
                        if (!(string.IsNullOrEmpty(selectionKey)))
                        {
                            keyIndex = httpText.IndexOf(selectionKey);
                            // ---- selectionKey指定なければ無条件で追加。
                        }
                        if (keyIndex >= 0)
                        {
                            string imageUrl = BasicPage1.GetImageUrl(httpText);
                            string title = BasicPage1.GetHttpTerm(httpText);
                            string subtitle = BasicPage1.GetHttpHost(httpText);
                            string description = httpText;
                            // ----
                            DataItem dataItem = new DataItem(imageUrl, title, subtitle, description);
                            dataItems.Add(dataItem);
                        }
                    }
                    else
                    {
                        break;
                    }
                }
            }
            // ----
            if (dataItems.Count > 0)
            {
                resultText = dataItems.Count.ToString();
            }
            else
            {
                resultText = "指定のキーに照合するhttpテキストはありません。";
            }
            // ----
            return dataItems;
        }
        // -------- イメージURL
        public static string GetImageUrl(string httpText)
        {
            if (BasicPage1.IsImageUrl(httpText))
            {
                return httpText;
            }
            return null;
        }
        // --------
        public static bool IsImageUrl(string httpText)
        {
            if (httpText.IndexOf(".gif") >= 0 ||
                httpText.IndexOf(".jpg") >= 0 ||
                httpText.IndexOf(".jpeg") >= 0 ||
                httpText.IndexOf(".bmp") >= 0 ||
                httpText.IndexOf(".png") >= 0 ||
                httpText.IndexOf(".wmf") >= 0)
            {
                return true;
            }
            return false;
        }
        // -------- HTTPホスト
        public static string GetHttpHost(string httpText)
        {
            int index = httpText.IndexOf("//");
            if (index >= 0)
            {
                int startIndex = index + "//".Length;
                index = httpText.IndexOf("/", startIndex);
                if (index >= 0)
                {
                    return httpText.Substring(startIndex, (index - startIndex));
                }
                return httpText.Substring(startIndex);
            }
            return null;
        }
        // -------- HTTPターム
        public static string GetHttpTerm(string httpText)
        {
            int startIndex = httpText.Length - 1;
            while (startIndex >= 0)
            {
                int index = httpText.LastIndexOf("/", startIndex);
                if (index < 0)
                {
                    return null;
                }
                // ----
                int topIndex = index + "/".Length;
                string httpTerm = httpText.Substring(topIndex, (startIndex - index));
                if (httpTerm.Length > 0)
                {
                    return httpTerm;
                }
                // ----
                startIndex = index - "/".Length;
            }
            return null;
        }
#if true
        // -------- ＃対象URLのエラー表示
        private async void ShowTargetUrlError(string targetUrl)
        {
            // ---- MessageDialogの生成。
            var messageDialog = new MessageDialog(targetUrl, "対象WebページURLエラー");

            // ---- コマンドの追加（コールバックメソッドの設定）。
            messageDialog.Commands.Add(new UICommand("強行", (command) =>
            {
                // ---- ▼アプリデータを保存。
                BasicPage1.TargetUrl = targetUrl;
                this.Frame.Navigate(typeof(BasicPage1));
            }));
            // ----
            messageDialog.Commands.Add(new UICommand("キャンセル", (command) =>
            {
                // ----  現対象URLをリセット。
                this.controlTargetUrl = BasicPage1.TargetUrl;
            })); 

            // ---- 既定コマンドの設定。
            messageDialog.DefaultCommandIndex = 1;

            // ---- メッセージダイアログの表示。
            await messageDialog.ShowAsync();
        }
#endif
        // -------- ！対象URLの変更
        private void ChangeTargetUrl(string targetUrl)
        {
            if(string.IsNullOrEmpty(targetUrl) ||
                targetUrl.IndexOf("http") != 0)
            {
                // ---- 対象URLのエラー表示。
                this.ShowTargetUrlError(targetUrl);
                return;
            }

            // ---- 現対象URLのプッシュ。
            BasicPage1.PushUrl(BasicPage1.TargetUrl);
#if true
            // ---- ▼アプリデータを保存。
            BasicPage1.TargetUrl = targetUrl;
            // ----
            this.Frame.Navigate(typeof(BasicPage1));
#else
            this.controlTargetUrl = targetUrl;
            // ---- ▼リフレッシュ。
            this.Refresh(targetUrl, this.controlSelectionKey);
#endif
        }

        // -------- ！検索ボタン
        private void button_Find_Click(object sender, RoutedEventArgs e)
        {
#if true
            // ---- 対象URLの変更。
            this.ChangeTargetUrl(this.controlTargetUrl);
#else
            // ---- ▼アプリデータを保存。
            BasicPage1.TargetUrl = this.controlTargetUrl;

            // ---- ▼リフレッシュ。
            this.Refresh(this.controlTargetUrl, this.controlSelectionKey);
#endif
        }

        // -------- ！対象URLの変更
        private void button_ChangeTargetUrl_Click(object sender, RoutedEventArgs e)
        {
            string selectedUrl = null;
            // ----
            DataItem selectedDataItem = this.controlSelectedDataItem;
            if (selectedDataItem != null)
            {
                selectedUrl = selectedDataItem.Description;

            }
            else
            {
                selectedUrl = this.webView_TargetWebPage.Source.AbsoluteUri;
                // ---- ※表示URLを取得。
            }

            // ---- 対象URLの変更。
            if (!(string.IsNullOrEmpty(selectedUrl)))
            {
                this.ChangeTargetUrl(selectedUrl);
            }
        }
        // -------- ！戻る
        protected override void GoBack(object sender, RoutedEventArgs e)
        {
            BasicPage1.TargetUrl = BasicPage1.PopUrl();
            // ----
            base.GoBack(sender, e);
        }
        // -------- ！ホームページ
        private void button_HomePage_Click(object sender, RoutedEventArgs e)
        {
#if true
            // ---- ホームへ
            BasicPage1.TargetUrl = BasicPage1.HomeUrl();
            // ----
            this.Frame.Navigate(typeof(BasicPage1));
#else
            this.Frame.Navigate(typeof(BasicPage2));
#endif
        }
        // -------- ！ピックアップURLの選択
        private void listView_PickupUrls_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (e.AddedItems.Count > 0)
            {
                string pickupUrl = ((DataItem)e.AddedItems[0]).Description;

                // ---- ピックアップURLの表示。
                this.NavigateWebView(pickupUrl);
            }
        }

        // -------- ！選択URLの保存
        private async void button_SavePickupUrl_Click(object sender, RoutedEventArgs e)
        {
            string selectedUrl = this.textBlock_SelectedUrl.Text;
            //-string targetUrl = this.webView_TargetWebPage.Source.AbsoluteUri;
            // ---- ※表示URLを取得。

            if (this.EnsureUnsnapped())
            {
                string fileName = BasicPage1.GetHttpTerm(selectedUrl) + ".txt";
#if false
                FolderPicker folderPicker = new FolderPicker();
                folderPicker.ViewMode = PickerViewMode.List;
                folderPicker.SuggestedStartLocation = PickerLocationId.Desktop;
                folderPicker.FileTypeFilter.Add(".txt");
                StorageFolder storageFolder = await folderPicker.PickSingleFolderAsync();
                if (storageFolder != null)
                {
                    StorageFile storageFile = await storageFolder.CreateFileAsync(fileName);
                    await Windows.Storage.FileIO.WriteTextAsync(storageFile, selectedUrl);
                }
#else
                FileSavePicker fileSavePicker = new FileSavePicker();
                fileSavePicker.SuggestedStartLocation = PickerLocationId.Desktop;
                fileSavePicker.SuggestedFileName = fileName;
                fileSavePicker.FileTypeChoices.Add("テキスト", new List<string>() { ".txt" });
                StorageFile storageFile = await fileSavePicker.PickSaveFileAsync();
                if (storageFile != null)
                {
                    await Windows.Storage.FileIO.WriteTextAsync(storageFile, selectedUrl);
                }
#endif
            }
        }
        // --------
        public bool EnsureUnsnapped()
        {
            bool unsnapped = ((ApplicationView.Value != ApplicationViewState.Snapped) || ApplicationView.TryUnsnap());
            return unsnapped;
        }
        // -------- ！選択URLのオープン
        private async void button_OpenPickupUrl_Click(object sender, RoutedEventArgs e)
        {
            string selectedUrl = this.textBlock_SelectedUrl.Text;
            //-string targetUrl = this.webView_TargetWebPage.Source.AbsoluteUri;
            // ---- ※表示URLを取得。

            if (this.EnsureUnsnapped())
            {
                FileOpenPicker fileOpenPicker = new FileOpenPicker();
                fileOpenPicker.ViewMode = PickerViewMode.List;
                fileOpenPicker.SuggestedStartLocation = PickerLocationId.Desktop;
                fileOpenPicker.FileTypeFilter.Add(".txt");
#if false
#else
                fileOpenPicker.FileTypeFilter.Add(".jpg");
                fileOpenPicker.FileTypeFilter.Add(".jpeg");
                fileOpenPicker.FileTypeFilter.Add(".png");
#endif
                StorageFile storageFile = await fileOpenPicker.PickSingleFileAsync();
                if (storageFile != null)
                {
#if true
                    string text = await Windows.Storage.FileIO.ReadTextAsync(storageFile);
                    await Windows.Storage.FileIO.AppendTextAsync(storageFile, Environment.NewLine + DateTime.Now.ToString());
                    // ----
                    BasicPage1.TargetUrl = text;
                    this.Frame.Navigate(typeof(BasicPage1));
#else
                    string fileName = "@" + storageFile.Name;
                    await storageFile.RenameAsync(fileName);
#endif
                }
            }
        }

#if false
        // -------- ＃ブラウザの表示
        private async void ShowBrowser(string url)
        {
            try
            {
                var uri = new System.Uri(url);
                await Windows.System.Launcher.LaunchUriAsync(uri);

                // ----
                this.Focus(Windows.UI.Xaml.FocusState.Pointer);
            }
            catch (Exception exception)
            {
                this.pageTitle.Text = exception.Message;
            }
        }
#endif


    }
}
