﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
// --------
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Imaging;
// --------
namespace PerfectCS_2012
{
    public class DataItem// : Common.BindableBase
    {
        // --------
        public static List<DataItem> SelectKeyDataItems(List<DataItem> targetDataItems, string keyText)
        {
            List<DataItem> dataItems = new List<DataItem>();
            if (targetDataItems != null)
            {
                foreach (DataItem dataItem in targetDataItems)
                {
                    if (dataItem.Title != null &&
                        dataItem.Title.IndexOf(keyText) >= 0)
                    {
                        dataItems.Add(dataItem);
                    }
                }
            }
            return dataItems;
        }
        // --------
        public static List<DataItem> SelectImegeDataItems(List<DataItem> targetDataItems)
        {
            List<DataItem> dataItems = new List<DataItem>();
            if (targetDataItems != null)
            {
                foreach (DataItem dataItem in targetDataItems)
                {
                    if (dataItem.Image != null)
                    {
                        dataItems.Add(dataItem);
                    }
                }
            }
            return dataItems;
        }
        // -------- ●
        public DataItem(string imageUrl, string title, string subtitle, string description)
        {
            this.ImageUrl = imageUrl;
            this.Title = title;
            this.Subtitle = subtitle;
            this.Description = description;
        }
        // -------- for ListView
        public override string ToString() { return this.Description; }

        // --------
        private string _imageUrl;
        public string ImageUrl
        {
            get { return this._imageUrl; }
            set { this._imageUrl = value; }
        }
        // --------
        private ImageSource _image;
        public ImageSource Image
        {
            get
            {
                if (this._image == null && this.ImageUrl != null)
                {
                    try
                    {
                        this._image = new BitmapImage(new Uri(this.ImageUrl));
                    }
                    catch (Exception exception)
                    {
                        string message = exception.Message;
                        // ----
                    }
                }
                return this._image;
            }
        }
        // --------
        //-public string Title { get; set; }
        private string _title;
        public string Title
        {
            get { return this._title; }
            set { this._title = value; }
            //set { this.SetProperty(ref this._title, value); }
        }
        // --------
        //-string Subtitle { get; set; }
        private string _subtitle;
        public string Subtitle
        {
            get { return this._subtitle; }
            set { this._subtitle = value; }
        }
        // --------
        //-string Description { get; set; }
        private string _description;
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
    }
}
