
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 03/03/2013 18:46:21
-- Generated from EDMX file: C:\PerfectC# Examples 2012\EntityFramework\EntityFramework\ReceiptModel.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [PerfectCS_2012];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_ReceiptReceiptDetail]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[ReceiptDetails] DROP CONSTRAINT [FK_ReceiptReceiptDetail];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Receipts]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Receipts];
GO
IF OBJECT_ID(N'[dbo].[ReceiptDetails]', 'U') IS NOT NULL
    DROP TABLE [dbo].[ReceiptDetails];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Receipts'
CREATE TABLE [dbo].[Receipts] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [Date] datetime  NOT NULL,
    [Title] nvarchar(max)  NOT NULL,
    [Amount] decimal(18,0)  NOT NULL
);
GO

-- Creating table 'ReceiptDetails'
CREATE TABLE [dbo].[ReceiptDetails] (
    [ID] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Value] decimal(18,0)  NOT NULL,
    [Quantity] int  NOT NULL,
    [Price] decimal(18,0)  NOT NULL,
    [Receipt_ID] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [ID] in table 'Receipts'
ALTER TABLE [dbo].[Receipts]
ADD CONSTRAINT [PK_Receipts]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- Creating primary key on [ID] in table 'ReceiptDetails'
ALTER TABLE [dbo].[ReceiptDetails]
ADD CONSTRAINT [PK_ReceiptDetails]
    PRIMARY KEY CLUSTERED ([ID] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [Receipt_ID] in table 'ReceiptDetails'
ALTER TABLE [dbo].[ReceiptDetails]
ADD CONSTRAINT [FK_ReceiptReceiptDetail]
    FOREIGN KEY ([Receipt_ID])
    REFERENCES [dbo].[Receipts]
        ([ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ReceiptReceiptDetail'
CREATE INDEX [IX_FK_ReceiptReceiptDetail]
ON [dbo].[ReceiptDetails]
    ([Receipt_ID]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------